package cs108.e;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

public final class Dump {
    public static void main(String[] args) throws IOException {
        try (InputStream s = new FileInputStream("allbytes.bin")) {
            int count, pos = 0;
            byte[] bs = new byte[16];
            while ((count = s.read(bs)) != -1) {
                System.out.printf("%n%05d:", pos);
                for (int b = 0; b < count; ++b)
                    System.out.printf(" %3d", Byte.toUnsignedInt(bs[b]));

                System.out.print("  |");
                for (int b = 0; b < count; ++b)
                    System.out.printf("%c", asASCIIPrintable(bs[b]));
                System.out.print("|");

                pos += count;
            }
        }
    }
    private static char asASCIIPrintable(int b) {
        return (32 <= b && b < 127) ? (char)b : '.';
    }
}
